"use strict";
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (Object.hasOwnProperty.call(mod, k)) result[k] = mod[k];
    result["default"] = mod;
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
const deepmerge = __importStar(require("deepmerge"));
/**
 * Merges a list of ConfigParseResults into a single ParseResult, with a single sls-congiguration
 *
 * @param results
 */
function mergeParseResults(results) {
    //console.log("mergeParseResults: ", results);
    return results.reduce((merged, item) => {
        return {
            slsConfigs: deepmerge.all([merged.slsConfigs, item.slsConfigs]),
            webpackConfigs: merged.webpackConfigs.concat(item.webpackConfigs),
            postBuilds: merged.postBuilds.concat(item.postBuilds),
            // usually, these fields should not be defined here, but only from the top-level configuration
            stackName: item.stackName !== undefined ? item.stackName : merged.stackName,
            assetsPath: item.assetsPath !== undefined ? item.assetsPath : merged.assetsPath,
            buildPath: item.buildPath !== undefined ? item.buildPath : merged.buildPath,
            region: item.region !== undefined ? item.region : merged.region
        };
    }, {
        slsConfigs: {},
        webpackConfigs: [],
        postBuilds: []
    });
}
exports.mergeParseResults = mergeParseResults;
//# sourceMappingURL=config-parse-result.js.map